/*globals define, window, CKEDITOR, jQuery, top*/

define([
    'testsuite/qunit',
    'testsuite/qunit-fixture!ep/ui/previeweditor-test',
    'jquery',

    'ep/ui/previeweditor',
    '$ready!'
], function (QUnit, fixture, $, ep) {
    window.$$ = undefined;

    QUnit.module("ep/ui/previeweditor", {
        setup: fixture.init,
        teardown: fixture.destroy
    });

    QUnit.asyncTest("ep/ui/previeweditor", function () {
        var jq;

        top.jq = jq = $;
        top.jQuery = top.$ = jQuery;

        QUnit.ok(CKEDITOR.instances.editorID === undefined, 'editor instance doesn\'t exist yet');

        var base = $('#baseId'),
            editor = ep('#editorID').uiPrevieweditor({
                name : 'editorName',
                height: base.height(),
                width: base.width(),
                holder: $('#holderId'),
                base: base,
                navbar: 'testclass'
            });

        // is defined
        QUnit.equal(
            $.isFunction($.ui.uiPrevieweditor),
            true,
            "$.isFunction($.ui.uiPrevieweditor)"
        );

        // check prototype methods
        $.each(['toggleToolbar'],  function (i, fn) {

            QUnit.equal(
                $.isFunction($.ui.uiPrevieweditor.prototype[fn]),
                true,
                fn + " is a method of $.ui.uiPrevieweditor"
            );

        });

        QUnit.ok(CKEDITOR.instances.editorID !== undefined, 'editor instance exists');

        // external toolbar is hidden
        QUnit.equal(
            $('#EditorTools').hasClass('NavBarInvisible'),
            true,
            "External toolbar (red background) is hidden - .hasClass('NavBarInvisible')"
        );
        // standard toolbar is shown
        QUnit.equal(
            $('#PageTools').hasClass('NavBarVisible'),
            true,
            "Standard toolbar (green background) is shown - .hasClass('NavBarVisible')"
        );


        //ep('#editorID').uiPrevieweditor('toggleToolbar', true);
        CKEDITOR.instances.editorID.focusManager.focus();

        setTimeout(function () {

            // additional CSS class was set
            QUnit.equal(
                $(CKEDITOR.instances.editorID.container.$).find('iframe').contents().find('html').hasClass('cke_testclass'),
                true,
                "set option navbar: 'testclass' => iFrame for editor has additional CSS class"
            );

            // external toolbar is shown
            QUnit.equal(
                $('#EditorTools').hasClass('NavBarVisible'),
                true,
                "External toolbar (red background) is shown - .hasClass('NavBarVisible')"
            );
            // standard toolbar is hidden
            QUnit.equal(
                $('#PageTools').hasClass('NavBarInvisible'),
                true,
                "Standard toolbar (green background) is hidden - .hasClass('NavBarInvisible')"
            );

            // check destroy method of widget
            ep('#editorID').uiPrevieweditor('destroy');

            QUnit.ok(CKEDITOR.instances.editorID === undefined, 'editor was destroyed');

            QUnit.start();

        }, 4000);

    });
});